#ifndef CIT_COMM_H
#define CIT_COMM_H

#include <stdint.h>
#include <stdbool.h>

#include "libs/cit_common.h"

#ifdef   __cplusplus
extern "C"
{
#endif

typedef struct {
    void (*on_idle)(void);
    void (*on_recv_irq)(void);
} cit_config_t;

void cit_comm_init(const cit_config_t* config);

// -------- send --------

bool cit_comm_is_tx_busy(void);

void cit_comm_send(const uint8_t* data, uint32_t len);

// -------- receive --------

// internally a ring buffer with cit_frames
typedef struct {
    uint8_t size;
    const uint8_t* data;
} cit_comm_frame_t;

// returns NULL if no more frames
cit_comm_frame_t* cit_comm_get_frame(void);

void cit_comm_consume_frame(void);

#ifdef   __cplusplus
}
#endif

#endif

